## fpc 3.0.0+dfsg

=== fpcdocs/bunixex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean

OBJECTS= ex1 ex16 ex17 ex18 ex19 ex20 ex21 ex23 ex24 ex25 ex26 ex27 ex28 \
        ex31 ex32 ex33 ex35 ex36 ex41 ex53 ex54 ex57 ex58 ex59 ex7 ex72 \
        ex73 ex8 

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

=== fpcdocs/datutex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean execute

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 ex11 ex12\
        ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 ex21 ex22 ex23 ex24\
        ex25 ex26 ex27 ex28 ex29 ex30 ex31 ex32 ex33 ex34 ex35 ex36\
        ex37 ex38 ex39 ex40 ex41 ex42 ex43 ex44 ex45 ex46 ex47\
        ex48 ex49 ex50 ex51 ex52 ex53 ex54 ex55 ex56 ex57 ex58\
        ex59 ex60 ex61 ex62 ex63 ex64 ex65 ex66 ex67 ex68 ex69 ex70\
        ex71 ex72 ex73 ex74 ex75 ex76 ex77 ex78 ex79 ex80 \
        ex81 ex82 ex83 ex84 ex85 ex86 ex87 ex88 ex89 ex90 ex91 ex92 \
        ex93 ex94 ex95 ex96 ex97 ex98 ex99 ex100 ex101 ex102 ex103\
        ex104 ex105 ex106
        
# This might not be the same list as objects, since some of the
# tests might be interactive.
TOTEST=OBJECTS

LOGFILE=$(addsuffix .log, $(TOTEST))
        

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

execute: $(LOGFILE)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll *.ppw *.tmp *.log *.dat
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

$(LOGFILE): %.log: %.exe 
	$* > $*.log

=== fpcdocs/go32ex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)


# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean

OBJECTS=buffer callback flags getrunmd intpm keyclick meminfo outport \
  rmpmint seldes softint textmess vgasel 

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

=== fpcdocs/objectex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler
ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)
# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean execute

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 \
        ex11 ex12 ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 \
        ex21 ex22 ex23 ex24 ex25 ex26 ex27 ex28 ex29 ex30 \
        ex31 ex32 ex33 ex34 ex35 ex36 ex37 ex38 ex39 ex40 
        
# This might not be the same list as objects, since some of the
# tests might be interactive.
TOTEST=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8 ex9 ex10 \
        ex11 ex12 ex13 ex14 ex15 ex16 ex17 ex18 ex19 ex20 \
        ex21 ex22 ex23 ex24 ex25 ex26 ex27 ex28 ex29 ex30 \
        ex31 ex32 ex33 ex34 ex35 ex37 ex38 ex39 ex40 
        
LOGFILE=$(addsuffix .log, $(TOTEST))
        

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

tex : $(TEXOBJECTS) myobject.tex mysortc.tex

execute: $(LOGFILE)


onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS) mysortc.ppu myobject.ppu mysortc.tex myobject.tex test.dat
	-rm -f *.ow *.sw *.exe *.dll *.ppw *.log *.tmp 
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS) myobject.tex mysortc.tex: %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

$(LOGFILE): %.log: %.exe 
	$* > $*.log

=== fpcdocs/unixex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean

OBJECTS=    ex15 ex22 ex29 ex36 ex37 ex38 ex39 ex40  ex46\
          ex56    ex62 ex65 ex66 ex76 ex77 ex79 ex8 ex80 \
        ex9 ex91 

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))

all : $(OBJECTS)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	-rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	-rm -f *.ow *.sw *.exe *.dll
 
$(OBJECTS): %: %.pp
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

=== fpcdocs/videoex/Makefile ===
#######################################################################
#
# Makefile to compile all examples and convert them to LaTeX
# 
#######################################################################

# Compiler

override PATH:=$(patsubst %/,%,$(subst \,/,$(PATH)))
ifneq ($(findstring darwin,$(OSTYPE)),)
inUnix=1 #darwin
SEARCHPATH:=$(filter-out .,$(subst :, ,$(PATH)))
else
ifeq ($(findstring ;,$(PATH)),)
inUnix=1
SEARCHPATH:=$(filter-out .,$(subst :, ,$(PATH)))
else
SEARCHPATH:=$(subst ;, ,$(PATH))
endif
endif
SEARCHPATH+=$(patsubst %/,%,$(subst \,/,$(dir $(MAKE))))

ifndef FPC
ifdef PP
FPC=$(PP)
endif
endif
ifndef FPC
FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH))))
ifneq ($(FPCPROG),)
FPCPROG:=$(firstword $(FPCPROG))
FPC:=$(shell $(FPCPROG) -PB)
ifneq ($(findstring Error,$(FPC)),)
override FPC=ppc386
endif
else
override FPC=ppc386
endif
endif
override FPC:=$(subst $(SRCEXEEXT),,$(FPC))
override FPC:=$(subst \,/,$(FPC))$(SRCEXEEXT)

# Unit directory
# UNITDIR=/usr/lib/ppc/0.99.0/linuxunits


# Any options you wish to pass.
PPOPTS=

# Script to convert the programs to LaTeX examples which can be included.
PP2TEX=../pp2tex

# Script to collect all examples in 1 file.
MAKETEX=make1tex

#######################################################################
# No need to edit after this line.
#######################################################################

ifdef UNITDIR
PPOPTS:=$(PPOPTS) -Up$(UNITDIR);
endif

.SUFFIXES: .pp .tex

.PHONY: all tex clean

OBJECTS=ex1 ex2 ex3 ex4 ex5 ex6 ex7 ex8
# ex9
#        ex10 ex11 ex12 ex13  ex14 ex15 ex16 ex17 ex18

TEXOBJECTS=$(addsuffix .tex, $(OBJECTS))
override TEXOBJECTS:=$(TEXOBJECTS) vidutil.tex viddbg.tex

all : $(OBJECTS)

tex : $(TEXOBJECTS)

onetex : tex
	$(MAKETEX) $(TEXOBJECTS)

clean : 
	rm -f *.o *.s $(OBJECTS) $(TEXOBJECTS)
	rm -f vidutil.ppu vidutil.o viddbg.ppu viddbg.o Video.log
	rm -f *.ow *.sw *.exe *.dll
 
$(OBJECTS): %: %.pp vidutil.ppu
	$(FPC) $(PPOPTS) $*

$(TEXOBJECTS): %.tex: %.pp head.tex foot.tex
	$(PP2TEX) $*

vidutil.ppu: vidutil.pp
	$(FPC) $(PPOPTS) vidutil.pp

=== debian/changelog ===
fpc (3.0.0+dfsg-8) unstable; urgency=medium

  * add a further powerpc patch from upstream (hopefully really closes: #826300).

 -- Peter Michael Green <plugwash@debian.org>  Sat, 3 Sep 2016 03:05:00 +0000

fpc (3.0.0+dfsg-7) unstable; urgency=medium

  [ Paul Gevers ]
  * Now really bumb Standards to 3.9.8 (forgot control.in)
  * Make output of fix-fp-timestamps update unique
  * autopkgtest failed to run properly due to accidental removal of code
    in 3.0.0+dfsg-5 and missing g++
  * Add fp-utils-# and fp-docs-# to the Depends of fpc to get all packages
    installed
  * Add fix_powerpc_ftbfs_with_new_glibc.patch to fix the FTBFS on powerpc
    with glibc 2.23 (Closes: #826300)

  [ Peter Michael Green ]
  * Add elf tag to mark hardfp binaries as such. (Closes: #695547)
  * Add further-arm64-fixes.patch to fix IDE crash on arm64 (Closes:
    #830906)

 -- Paul Gevers <elbrus@debian.org>  Mon, 22 Aug 2016 22:03:07 +0200

fpc (3.0.0+dfsg-6) unstable; urgency=medium

  * Fix FTBFS due to wrong logic for latex files, we only need to ship
    fpc.sty and fakehtml.sty (the other files were never included in
    build-arch only builds anyways)

 -- Paul Gevers <elbrus@debian.org>  Thu, 02 Jun 2016 21:38:47 +0200

fpc (3.0.0+dfsg-5) unstable; urgency=medium

  * Don't install latex style files that are already in
    texlive-latex-recommended and more up-to-date there (Closes: #820445)
  * Let fpc-source break/replace fpc-src from upstream (LP: #1568072)
  * Update test suite: little rework + more reference files for different
    architectures
  * Add arm_UMULL_support_fix.patch to enable hedgewars to build with PIC
    (Follow-up from #813452)
  * Add fp-fix-timestamps to ease maintainers work to get reproducible
    builds where timestamps in ppu files are concerned and use it
  * Bump Standards to 3.9.8 (no changes)
  * Update FSF address where applicable
  * Fixed several spelling errors reported by Lintian
  * Add multiple lintian overrides to trim down the list
  * Add fp-units-gtk2 examples back

 -- Paul Gevers <elbrus@debian.org>  Wed, 01 Jun 2016 22:16:37 +0200

fpc (3.0.0+dfsg-4) unstable; urgency=medium

  [ Peter Michael Green ]
  * modify debian/patches/Keep-the-GOT-offset-in-a-virtual-register-for-i386-n.patch
    (Closes: Bug#818663)
    for compatibility with fpc 3.0.0 to fix FTBFS on i386
    + move globtype from implementation uses to interface uses in hlcgcpu.pas
    + remove "paras" parameter from thlcgcpu.a_call_name
    + Add symconst and aasmcpu to implementation uses in hlcgcpu.pas

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Tue, 22 Mar 2016 08:54:18 +0100

fpc (3.0.0+dfsg-3) unstable; urgency=medium

  [ Paul Gevers ]
  * Add fix_ppc64s_prt0.as_as_shown_by_cge.patch to let castle-game-engine
    build on ppc64
  * Test suite was failing on the old d/rules targets (need to generate
    new reference data before it can be completely run succesfull)
  * Change Vcs-* to https
  * Fix up typo and missing dh-exec in d/control.in
  * Move libtar from fp-units-misc to fp-units-base now that fpmkunit
    depends on it and add appropriate versioned Breaks/Replaces.
  * Bump Standards to 3.9.7 (no changes)

  [ Abou Al Montacir ]
  * Back ported some commits from upstream trunk to fix PIC issues.
    (Closes: Bug#813452)

 -- Paul Gevers <elbrus@debian.org>  Fri, 18 Mar 2016 08:48:55 +0100

fpc (3.0.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * Make reverse dependent package more reproducible by adding
    let_ppudump_honor_TZ_var.patch
  * Add after_patch_arm64_systems.pas.patch (Closes: #807479)
  * Fix i386 issue with duplicate files in multiple packages
  * Move cairo units from gfx to gtk2 package (Closes: #810573)
  * Switch to 'dpkg-parsechangelog --show-field' instead of bumping
    build-depends on dpkg-dev to >=1.17.21.

 -- Paul Gevers <elbrus@debian.org>  Thu, 28 Jan 2016 20:04:04 +0100

fpc (3.0.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Reproducibility never ends: add honor_SOURCE_DATE_EPOCH_in_date.patch
    to improve some timestamps in binaries

 -- Paul Gevers <elbrus@debian.org>  Fri, 27 Nov 2015 14:51:44 +0100

fpc (3.0.0~rc2+dfsg-3) experimental; urgency=medium

  * Make package finally build reproducible (hopefully)
  * Add fpm files to the respective packages
  * Update auto-pkg-tests with results from CI + runs on my amd64 system
  * use debfix to create and dh_lintian to install lintian overrides
  * Update testsuite for 3.0.0 layout
  * Restructure the clean targets to allow time reduction if desired
  * Reorganize d/rules to make sure the source is copied early
  * Add fix_typo_in_ppc64.patch to allow ppc64 to build again and don't
    install graph and opencl there as these units aren't build

 -- Paul Gevers <elbrus@debian.org>  Thu, 12 Nov 2015 20:35:17 +0100

fpc (3.0.0~rc2+dfsg-2) experimental; urgency=medium

  * The second Edmund Grimley Evans release: arm64 bootstrapped
    (Closes: #784569)
    - enable arm64 patches
  * Another try to fix the FTBFS on armhf (missed this dh-exec issue)

 -- Paul Gevers <elbrus@debian.org>  Sat, 31 Oct 2015 11:16:23 +0100

fpc (3.0.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream release candidate
    - Remove obsolete patch
    - Update + refresh patches that require changes
  * Fix FTBFS on powerpc (the previous fix was not complete)
  * Fix FTBFS on armhf, the logic was not in the right place
  * Add patches (but don't apply them yet) to support arm64, see
    bug 784569
  * Simplify logic in *.install.in and d/rules for arch dependent
    install by using dh-exec

 -- Paul Gevers <elbrus@debian.org>  Wed, 28 Oct 2015 19:40:13 +0100

fpc (3.0.0~rc1+dfsg-2) experimental; urgency=medium

  * The first Edmund Grimley Evans release (thanks for your work)
  * Fix FTBFS on i386, powerpc and ppc64 with new patch:
    fix_FTBFS_on_linux_not_amd64.patch (Closes: #800811)
  * Fix FTBFS on armhf by not optimizing during the first cycles of


=== debian/control ===
Source: fpc
Section: devel
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Carlos Laviola <claviola@debian.org>,
 Paul Gevers <elbrus@debian.org>,
 Peter Michael Green <plugwash@debian.org>,
 Torsten Werner <twerner@debian.org>,
Standards-Version: 3.9.8
Build-Depends:
 binutils,
 debhelper (>= 9),
 dh-exec (>=0.22),
 fp-compiler,
 fp-units-base,
 fp-units-fcl,
 fp-utils,
 ghostscript,
 libncurses-dev,
 mawk | awk,
 po-debconf,
 txt2man,
Build-Depends-Indep:
 hevea,
 rdfind,
 symlinks
Vcs-Git: https://anonscm.debian.org/git/pkg-pascal/fpc.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-pascal/fpc.git
Homepage: http://www.freepascal.org/

Package: fpc-3.0.0
Architecture: all
Depends:
 fp-compiler-3.0.0 (>= ${binary:Version}),
 fp-ide-3.0.0 (>= ${binary:Version}),
 fp-units-base-3.0.0 (>= ${binary:Version}),
 fp-units-db-3.0.0 (>= ${binary:Version}),
 fp-units-fcl-3.0.0 (>= ${binary:Version}),
 fp-units-fv-3.0.0 (>= ${binary:Version}),
 fp-units-gfx-3.0.0 (>= ${binary:Version}),
 fp-units-gtk2-3.0.0 (>= ${binary:Version}),
 fp-units-math-3.0.0 (>= ${binary:Version}),
 fp-units-misc-3.0.0 (>= ${binary:Version}),
 fp-units-multimedia-3.0.0 (>= ${binary:Version}),
 fp-units-net-3.0.0 (>= ${binary:Version}),
 fp-units-rtl-3.0.0 (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.0
Suggests:
 fp-docs-3.0.0 (>= ${source:Upstream-Version}),
 lazarus
Provides:
 fpc
Breaks:
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - SDK-3.0.0 suite
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This metapackage pulls in all the FPC packages provided for this
 architecture. Experienced users may instead prefer to install the particular
 packages they require by hand.

Package: fpc-source-3.0.0
Architecture: all
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fpc-source
Breaks:
 fpc-source (<= 2.4.0-3),
 fpc-src
Replaces:
 fpc-source (<= 2.4.0-3),
 fpc-src
Description: Free Pascal - SDK source code
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains Free Pascal's own source code. It is meant to be used by
 the Lazarus IDE.

Package: fp-compiler-3.0.0
Architecture: any
Depends:
 binutils,
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.0 (>= ${binary:Version})
Suggests:
 fp-docs-3.0.0 (>= ${source:Upstream-Version}),
 mingw32-binutils
Provides:
 fp-compiler
Breaks:
 fp-compiler (<= 2.4.0-3),
 fp-utils-2.4.2 (<= 2.4.2-3),
 fp-utils-2.4.4 (<= 2.4.4-2),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-compiler (<= 2.4.0-3),
 fp-utils-2.4.4 (<= 2.4.4-1),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - compiler
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This package contains the command line compiler.

Package: fp-ide-3.0.0
Architecture: any
Depends:
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-utils-3.0.0 (>= ${binary:Version})
Suggests:
 fp-docs-3.0.0 (>= ${source:Upstream-Version})
Provides:
 fp-ide
Breaks:
 fp-ide (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-ide (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - IDE
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 Extensions have been added to the language, such as function overloading,
 creation and linking of shared libraries, and Delphi language extensions
 including classes, exceptions, ANSI strings, and open arrays.
 .
 This package contains the Integrated Development Environment (IDE). The IDE
 has an internal compiler.

Package: fp-utils-3.0.0
Architecture: any
Depends:
 fpc-source-3.0.0,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-compiler-3.0.0 (= ${binary:Version})
Provides:
 fp-utils
Breaks:
 fp-compiler (<= 2.4.0-3),
 fp-units-gfx (<= 2.4.2-2),
 fp-units-gfx-2.4.2 (<= 2.4.2-2),
 fp-utils (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-compiler (<= 2.4.0-3),
 fp-utils (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - utilities
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains some handy utilities for use with the Free Pascal
 Compiler:
  * data2inc   convert binary/text data to include files;
  * fpcmake    create Makefile from Makefile.fpc;
  * h2pas      convert .h files to Pascal units;
  * plex/pyacc Pascal Lex and Yacc implementations;
  * ppdep      create a dependency file for use with Makefiles;
  * ppudump    dump the information stored in a .ppu (unit) file;
  * ppufiles   show needed files for units;
  * ppumove    place multiple units in a shared library;
  * ptop       beautify source.

Package: fp-docs-3.0.0
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 fp-docs
Breaks:
 fp-docs (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-docs (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - documentation
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package provides documentation for the Free Pascal Compiler in HTML
 format.

Package: fp-units-rtl-3.0.0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 fp-compiler-3.0.0 (= ${binary:Version})
Provides:
 fp-units-rtl,
 fpc-abi-3.0.0
Breaks:
 fp-units-rtl (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-units-rtl (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - runtime libraries
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the RunTime Libraries for the Free Pascal Compiler.

Package: fp-units-base-3.0.0
Architecture: any
Depends:
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 uuid-dev
Provides:
 fp-units-base
Breaks:
 fp-units-base (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
 fp-units-misc-3.0.0 (<= 3.0.0+dfsg-2),
Replaces:
 fp-units-base (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
 fp-units-misc-3.0.0 (<= 3.0.0+dfsg-2),
Description: Free Pascal - base units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains Free Pascal units for common libraries (some of which
 are also required by the Free Component Library): NCurses, X11 (Xlib,
 Xutil), and ZLib.

Package: fp-units-fcl-3.0.0
Architecture: any
Depends:
 fp-units-base-3.0.0 (= ${binary:Version}),
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-fcl
Breaks:
 fp-units-fcl (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-units-fcl (<= 2.4.0-3)
Description: Free Pascal - Free Component Library
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the Free Component Library for the Free Pascal Compiler.

Package: fp-units-fv-3.0.0
Architecture: any
Depends:
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-fv
Breaks:
 fp-units-fv (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-units-fv (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - Free Vision units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a
 completely portable RunTime Library (RTL) available on many platforms and
 compatible with Turbo Pascal, along with a platform-independent class-based
 Free Component Library (FCL) adding many Delphi extensions and interfacing
 with many popular open source libraries.
 .
 This package contains the Free Vision units for the Free Pascal Compiler
 (which provide a framework for developing text user interfaces).

Package: fp-units-gtk2-3.0.0
Architecture: any
Depends:
 fp-units-fcl-3.0.0 (= ${binary:Version}),
 fp-units-rtl-3.0.0 (= ${binary:Version}),
 libgtk2.0-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 fp-units-gtk2
Breaks:
 fp-units-gtk2 (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Replaces:
 fp-units-gtk2 (<= 2.4.0-3),
 fpc (<= 3.0.0+dfsg-0),
Description: Free Pascal - GTK+ 2.x units
 The Free Pascal Compiler is an Object Pascal compiler supporting both Delphi
 and Turbo Pascal 7.0 dialects, as well as Mac Pascal dialects. It provides a

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Free Pascal

DEB_PACKAGE_NAME = fpc
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use pdf/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter l2h/4ht/hevea or html for (default)
CONVERTER=hevea
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}
endif
# Undefine FPC if it was set
unexport FPC
# Build new compiler name
CPU_SOURCE=$(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)
CPU_TARGET=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
# Take care that Debian uses amd64 while FPC perfers x86_64 instead
CPU_SOURCE := $(subst amd64,x86_64,${CPU_SOURCE})
CPU_TARGET := $(subst amd64,x86_64,${CPU_TARGET})
# Take care that Debian uses arm64 while FPC perfers aarch64 instead
CPU_SOURCE := $(subst arm64,aarch64,${CPU_SOURCE})
CPU_TARGET := $(subst arm64,aarch64,${CPU_TARGET})
# Take care that debian uses ppc64 while FPC prefers powerpc64 instead
CPU_SOURCE := $(subst ppc64,powerpc64,${CPU_SOURCE})
CPU_TARGET := $(subst ppc64,powerpc64,${CPU_TARGET})
# Shuld get rid of this one day, as it is done automatically  by FPC make files
ifeq ($(CPU_TARGET),m68k)
PPSUF=68k
endif
ifeq ($(CPU_TARGET),i386)
PPSUF=386
endif
ifeq ($(CPU_TARGET),x86_64)
PPSUF=x64
endif
ifeq ($(CPU_TARGET),powerpc)
PPSUF=ppc
endif
ifeq ($(CPU_TARGET),powerpc64)
PPSUF=ppc64
endif
ifeq ($(CPU_TARGET),alpha)
PPSUF=axp
endif
ifeq ($(CPU_TARGET),arm)
PPSUF=arm
endif
ifeq ($(CPU_TARGET),aarch64)
PPSUF=a64
endif
ifeq ($(CPU_TARGET),sparc)
PPSUF=sparc
endif

ifneq ($(CPU_SOURCE),$(CPU_TARGET))
PPPRE=ppcross
else
PPPRE=ppc
endif

PPNEW=$(PPPRE)$(PPSUF)

OS_TARGET=$(subst kfreebsd,freebsd,$(shell dpkg-architecture -qDEB_HOST_ARCH_OS))

FPCTARGET=$(CPU_TARGET)-$(OS_TARGET)
# Get version information from changelog file
DEB_VERSION:=$(shell dpkg-parsechangelog --show-field Version)
DEB_DATE:=$(shell date --utc --date="`dpkg-parsechangelog --show-field Date`" +%Y/%m/%d)
DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
export PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
endif
# Get directories
INSTALL_DIR=${CURDIR}/debian/tmp
BIN_DIR=${INSTALL_DIR}/usr/bin
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
DOC_DIR=${INSTALL_DIR}/usr/share/doc
SRC_DIR=${INSTALL_DIR}/usr/share/fpcsrc/${DEB_UPSTREAM_MAIN_VERSION}
EXAMPLE_TEMP=${INSTALL_DIR}/usr/share/doc/fpc-${DEB_UPSTREAM_MAIN_VERSION}
STY_DIR=${INSTALL_DIR}/usr/share/texmf/tex/latex/fpc-${DEB_UPSTREAM_MAIN_VERSION}
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
ifndef MV
MV=mv
endif
RM:=rm -rf
# Get fpcmake from path if none is specified.
ifndef FPCMAKE
# In 3.0.0rc1 building the new fpcmake doesn't work outside the full build
#FPCMAKE=fpcsrc/utils/fpcm/fpcmake
FPCMAKE=$(shell which fpcmake)
endif
# Undefine FPCDIR if it was set
unexport FPCDIR
NEWPP=$(CURDIR)/fpcsrc/compiler/$(PPNEW)
NEWFPDOC=$(CURDIR)/fpcsrc/utils/fpdoc/fpdoc
# Set default compilation options
DEB_BUILD_FPC_OPT=debian/deb-build-fpc.cfg
DEB_HOST_FPC_OPT=debian/deb-host-fpc.cfg
BUILDOPTS=PP=$(NEWPP) OPT='@${CURDIR}/${DEB_HOST_FPC_OPT}'
ifdef CROSSOPT
BUILDOPTS+= CROSSOPT=${CROSSOPT}
endif
INSTALLOPTS=INSTALL_PREFIX=$(INSTALL_DIR)/usr PP=$(NEWPP)

export GDBLIBDIR=/usr/lib

ifeq ($(CPU_TARGET),arm)
  DEBIANARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
  # Disable optimization for the first runs as there may be bugs associated
  # with that, preventing proper building new versions (cf bug 800811)
  #
  # Unsure if the -d option is still needed, this code was originally used to
  # bootstrap other arm flavors
  CYCLEOPTS:=OPT='@${CURDIR}/${DEB_HOST_FPC_OPT} -dFPC_$(DEBIANARCH)' OPTLEVEL1=-O-
else
  CYCLEOPTS:=OPT='@${CURDIR}/${DEB_HOST_FPC_OPT}'
endif

# Set default compilation options
DEB_HOST_MULTIARCH ?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_MULTIARCH ?=$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

FPMAKE_BUILDOPTS=FPMAKE_SKIP_CONFIG='-n @${CURDIR}/${DEB_BUILD_FPC_OPT}'

LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS | sed -e 's/-Wl,//g' -e 's/,/ /g')

# Until we switch to shorthand dh, we need to set this ourselves for
# reproducible builds
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

#export DH_VERBOSE=1

###################
# Clean
#

# The default clean target is very heavy for an already clean tree because it
# regenerates all the Makefiles from Makefile.fpc files to be able to call all
# the upstream distclean targets. Therefor the clean target is split into
# multiple components and you can fool the makefiles target when ZERO generated
# Makefiles are found by setting the variable MAY_FOOL_CLEAN to anything but
# the empty string. This is propably a reasonable trade-off under all
# circumstances, but to prevent anything bad from happening during official
# builds, it is not the default.
clean: check-makefiles clean-all-but-makefiles clean-makefiles
	# Make sure the debconf translations are always up-to-date
	debconf-updatepo
	dh_clean

# See comment above clean target. Fool make-file when approriate
check-makefiles:
ifdef MAY_FOOL_CLEAN
	for fpcfile in `find . -name Makefile.fpc` ; do \
		if [ -f `dirname $$fpcfile`/Makefile ] ; then \
			GOINGTOFOOLCLEAN=false ; \
		fi ; \
	done ; \
	if [ "$$GOINGTOFOOLCLEAN" != false ] ; then \
		echo Beware of empty Makefiles: we are going to fool the makefiles target now ; \
		for fpcfile in `find . -name Makefile.fpc` ; do \
			touch `dirname $$fpcfile`/Makefile ; \
		done ; \
		touch makefiles-stamp ; \
	fi
endif

# In essence, this is the real clean target, except it doesn't remove the
# generated Makefiles. It should do ALL the other cleaning though.
clean-all-but-makefiles: makefiles
	dh_testdir

	# Call upstream clean targets
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc compiler_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc rtl_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc packages_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc ide_distclean
	[ ! -s fpcsrc/Makefile ]  || $(MAKE) -C fpcsrc utils_distclean
	[ ! -s fpcdocs/Makefile ] || $(MAKE) -C fpcdocs clean
	# Just in case they forgot something
	find -regex '.*\.\(a\|or?\|so\.*\|ppu\|compiled\)' -delete
	# Not all empty directories are cleaned up properly by the upstream
	find . -type d -empty -delete

	# Revert hardcoded dates
	sed --in-place "s/EncodeDate([^(^)]*)/Now/" fpcsrc/packages/fpmkunit/src/fpmkunit.pp
	sed --in-place "s/\\\\date\\\{.*\\\}/\\\\date\\\{\`date +'%B %Y'\`\\\}/" fpcdocs/Makefile.fpc

	# Remove build config files; because we use a variable, lets not put it in
	# d/clean
	rm -f $(DEB_BUILD_FPC_OPT)
	rm -f $(DEB_HOST_FPC_OPT)

	# Remove the gnome1, gtk1, fpgtk and imlib packages
	# as they depend on libraries long go removed from Debian.
	rm -rf fpcsrc/packages/gnome1
	rm -rf fpcsrc/packages/gtk1
	rm -rf fpcsrc/packages/imlib
	rm -rf fpcsrc/packages/fpgtk
	# The following packages depend on (at least) fpgtk and were
	# not build in Debian anyways. The makefiles target fails to run
	# if we remove the above, but not these because fpcmake checks
	# for all Makefile.fpc files and notices that the dependency is
	# not fullfilled.
	rm -rf fpcsrc/utils/fpdoc/fpde
	rm -rf fpcsrc/utils/fpmc

	dh_clean


makefiles: makefiles-stamp
makefiles-stamp: $(patsubst %.fpc,%,$(shell find demo fpcdocs fpcsrc -name Makefile.fpc))
	# Make files are now generated.
	touch $@

%Makefile:%Makefile.fpc ${FPCMAKE}
	# Regenerate make files using fpcmake.
	${FPCMAKE} -Tall -q $<

clean-makefiles:
	# Remove auto-generated Makefiles.
	${RM} makefiles-stamp
	find . -name Makefile.fpc -execdir sh -c '${RM} $$(basename {} .fpc)' ';'


###################
# Debian files
#

debian-files: debian-files-stamp
debian-files-stamp:debian/fixdeb debian/*.in
